VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Dump"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'====
'Dump
'====
'
'Adding the Dump class to a VB6 project produces a predeclared global
'object named Dump to your program.  You can call the default
'property HexAscii explicitly or implicitly passing a Byte Array or
'String to get back a Hex dump of the contents as a String value.
'
'NOTE:
'
'Dump (also known as Dump.HexAscii) can also be called from the
'Immediate window when an exception occurs or a breakpoint is
'encountered.  This is most useful with a Print statement as in:
'
'           ?Dump(<byte array or string>)
'

Private Const CRYPT_STRING_HEXASCIIADDR = 11

Private Declare Function CryptBinaryToString Lib "Crypt32" _
    Alias "CryptBinaryToStringW" ( _
    ByRef pbBinary As Byte, _
    ByVal cbBinary As Long, _
    ByVal dwFlags As Long, _
    ByVal pszString As Long, _
    ByRef pcchString As Long) As Long

Private Function DumpItem(ByRef Bytes() As Byte) As String
    Dim lngOutLen As Long
    
    If UBound(Bytes) < 0 Then
        DumpItem = "* Empty *"
    Else
        'Determine output string length required.
        CryptBinaryToString Bytes(LBound(Bytes)), _
                            UBound(Bytes) - LBound(Bytes) + 1, _
                            CRYPT_STRING_HEXASCIIADDR, _
                            0&, _
                            lngOutLen
        DumpItem = String(lngOutLen, 0)
        
        'Convert binary to dump format.
        If CryptBinaryToString(Bytes(LBound(Bytes)), _
                               UBound(Bytes) - LBound(Bytes) + 1, _
                               CRYPT_STRING_HEXASCIIADDR, _
                               StrPtr(DumpItem), _
                               lngOutLen) <> 0 Then
        Else
            DumpItem = "* System error " & CStr(Err.LastDllError) & " *"
        End If
    End If
End Function

Public Property Get HexAscii(ByRef Target As Variant) As String
Attribute HexAscii.VB_Description = "Format Target item as Hex & Ascii & Address String"
Attribute HexAscii.VB_UserMemId = 0
    'Default property!
    Dim bytBuffer() As Byte
    
    Select Case VarType(Target)
        Case vbByte Or vbArray, vbString
            bytBuffer = Target
            HexAscii = DumpItem(bytBuffer)
        
        Case Else
            HexAscii = "* Unsupported type *"
            Exit Property
    End Select
End Property
